Bug 56483 - add disableKeepAlivePercentage similar to tomcat http connector
Summary: add disableKeepAlivePercentage similar to tomcat http connector
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: Core (show other bugs)
Version: 2.2.27
Hardware: PC Linux
: P2 enhancement (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2014-05-02 15:49 UTC by Brett Okken
Modified: 2018-11-07 21:08 UTC (History)
0 users



Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Brett Okken 2014-05-02 15:49:20 UTC
The tomcat7 http connector[1] has a configuration for disableKeepAlivePercentage which will stop allowing keep alive when a certain percentage of the available connections are in use. This would be a nice feature for httpd to allow for managing keep alive also.

[1] - https://tomcat.apache.org/tomcat-7.0-doc/config/http.html
Comment 1 Eric Covener 2014-05-02 16:15:47 UTC
Probably only useful on non-event MPM, I am surprised tomcat ties up a thread w/ each keepalive connection. Am I misunderstanding the feature?
Comment 2 Brett Okken 2014-05-02 18:10:54 UTC
The goal (at least from my perspective) is more about protecting from running out of available connections during a spike in requests because of connections being held open by keep alive.
Comment 3 Rainer Jung 2014-05-03 03:03:57 UTC
Tomcat has three connectors, Blocking I/O (BIO) which uses one thread per connection, NIO which maps active connections to threads and APR which uses the native APR libs to achieve the same goal.

Only the first connector has a problem with HTTP Keep-Alive and thread use and only the first connector implements disableKeepAlivePercentage. Default value is 75 (%) meaning that if 75% of the threads are tied to connections any new connection has Keep-Alive set to off.

Could be interesting for any MPM except event(opt).
Comment 4 William A. Rowe Jr. 2018-11-07 21:08:57 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.